<i18n>
{
  "fr": {
    "message-1": "Les émissions liées aux remboursements de <b>frais de déplacement</b> (codes Nacres",
    "message-2": ") <b>représentent plus de</b>",
    "message-3": "<b>des émissions du module « missions »</b>",
    "message-4": "Voulez-vous saisir les déplacements correspondants dans le module « missions » ? Si oui, saisissez-les et supprimez les montants facturés pour ces déplacements dans ces codes Nacres",
    "message-5": "Si non, ces émissions seront comptabilisées en achats et sous-estimeront les émissions des déplacements en missions de votre laboratoire.",
    "message-6": "contre",
    "message-7": "Attention"
  },
  "en": {
    "message-1": "Emissions linked to the reimbursement of <b>travel expenses</b> (Nacres codes",
    "message-2": ") <b>represent more than</b>",
    "message-3": "<b>of the emissions from the « business travel » module</b>",
    "message-4": "Do you want to enter the corresponding trips in the « business travel » module? If so, enter them and remove the amounts invoiced for these trips from the Nacres codes",
    "message-5": "If not, these emissions will be counted as purchases and will underestimate the emissions of your laboratory's business travel." ,
    "message-6": "versus",
    "message-7": "Warning"
  }
}
</i18n>

<template>
  <div style="display:inline;">
    <b-notification
      v-show="!isTag && displayWarning"
      :closable="false"
      type="is-danger is-light"
    >
      <span v-html="$t('message-1')" /> {{ TRAVELLING_EXPENSES_CODES.map(val => val.toUpperCase()).join(', ') }}<span v-html="$t('message-2')" />
      <b> {{ WARNING_RATE }}% </b> <span v-html="$t('message-3')" />, {{ purchasesEmissions | splitNumberTons}} {{ $t('t.co2e') }} {{ $t('message-6') }} {{ travelsEmissions | splitNumberTons}} {{ $t('t.co2e') }}.
      <br />
      <span v-html="$t('message-4')" /> {{ TRAVELLING_EXPENSES_CODES.map(val => val.toUpperCase()).join(', ') }}. <span v-html="$t('message-5')" />
    </b-notification>
    <div v-if="!isTag && displayWarning" />
    <b-tooltip
      v-show="isTag && displayWarning"
      size="is-large"
      type="is-danger is-light"
      multilined
    >
      <template v-slot:content>
        <span v-html="$t('message-1')" /> {{ TRAVELLING_EXPENSES_CODES.map(val => val.toUpperCase()).join(', ') }}<span v-html="$t('message-2')" />
        <b> {{ WARNING_RATE }}% </b> <span v-html="$t('message-3')" />, {{ purchasesEmissions | splitNumberTons}} {{ $t('t.co2e') }} {{ $t('message-6') }} {{ travelsEmissions | splitNumberTons}} {{ $t('t.co2e') }}.
        <br />
        <span v-html="$t('message-4')" /> {{ TRAVELLING_EXPENSES_CODES.map(val => val.toUpperCase()).join(', ') }}. <span v-html="$t('message-5')" />
      </template>
      <b-tag
        type="is-danger"
      >
        {{ $t('message-7') }}
      </b-tag>
    </b-tooltip>
  </div>
</template>

<script>
import Purchase from '@/models/carbon/Purchase.js'

export default {
  name: 'PurchasesWarning',
  props: {
    isTag: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      TRAVELLING_EXPENSES_CODES: Purchase.getTravellingExpensesCodes(),
      WARNING_RATE: Purchase.getWarningRate(),
      travelsEmissions: 0,
      purchasesEmissions: 0
    }
  },
  computed: {
    displayWarning: function () {
      if (this.purchasesEmissions !== 0 && this.travelsEmissions !== 0) {
        return (this.purchasesEmissions * 100 / this.travelsEmissions) >= this.WARNING_RATE
      } else {
        return false
      }
    }
  },
  methods: {
    forceComputation: function () {
      this.$store.dispatch('purchases/forceComputation')
      this.$store.dispatch('travels/forceComputation')
      if (!this.$store.getters['travels/computed']) {
        this.$store.dispatch('travels/compute')
      }
      if (!this.$store.getters['purchases/computed']) {
        this.$store.dispatch('purchases/compute')
      }
      let temissions = this.$store.getters['travels/results']
      this.travelsEmissions = temissions.total
      let pemissions = this.$store.getters['purchases/results']
      this.purchasesEmissions = pemissions.totalXA
    }
  }
}
</script>

<style>
.notification.is-danger.is-light {
  background-color: #feecf0 !important;
  color: #cc0f35 !important;
}
.b-tooltip.is-multiline.is-large .tooltip-content {
  width: 500px !important;
}
.b-tooltip.is-light .tooltip-content {
  background-color: #feecf0 !important;
  color: #cc0f35 !important;
  box-shadow: 0 1px 2px 1px #feecf0;
}
</style>
